# Milsko GUI Toolkit Documentation

## Table of Contents

Mw/Constants.h
  MwDIRECTION
  MwORIENTATION
  MwALIGNMENT
  MwDEFAULT
  MwMB_ICONMASK
  MwMB_BUTTONMASK
  MwMB_BUTTONOK
  MwMB_BUTTONCANCEL
  MwMB_BUTTONYES
  MwMB_BUTTONNO
  MwMB_BUTTONOKCANCEL
  MwMB_BUTTONYESNO
  MwMB_BUTTONYESNOCANCEL
Mw/Core.h
  MwDispatch
  MwDispatch2
  MwDispatch3
  MwCreateWidget
  MwVaCreateWidget
  MwVaListCreateWidget
  MwDestroyWidget
  MwLoop
  MwStep
  MwPending
  MwSetInteger
  MwSetText
  MwSetVoid
  MwGetInteger
  MwGetText
  MwGetVoid
  MwSetDefault
  MwVaApply
  MwVaListApply
  MwAddUserHandler
  MwDispatchUserHandler
  MwSetErrorHandler
  MwDispatchError
  MwGetBeforeStep
  MwForceRender
  MwForceRender2
Mw/Cursor.h
  MwCursorDefault
  MwCursorDefaultMask
  MwCursorCross
  MwCursorCrossMask
  MwCursorText
  MwCursorTextMask
Mw/Default.h
  MwDefaultBackground
  MwDefaultForeground
  MwDefaultBorderWidth
Mw/Draw.h
  MwParseColor
  MwLightenColor
  MwDrawRect
  MwDrawFrame
  MwDrawTriangle
  MwDrawFrameEx
  MwDrawText
  MwDrawTextEx
  MwLoadImage
  MwTextWidth
  MwTextHeight
  MwGetColor
  MwLoadRaw
  MwLoadXPM
  MwParseColorName
Mw/Error.h
  MwErrorEnum_T
  MwEsuccess
  MwEerror
  MwGetLastError
Mw/Font.h
  MwFontData[]
  MwBoldFontData[]
Mw/Icon.h
  MwIconError[]
  MwIconInfo[]
  MwIconNews[]
  MwIconNote[]
  MwIconQuestion[]
  MwIconWarning[]
Mw/LowLevel.h
Mw/MachDep.h
Mw/MessageBox.h
  MwMessageBox
  MwMessageBoxGetChild
Mw/Milsko.h
Mw/StringDefs.h
Mw/TypeDefs.h
Mw/Unicode.h
  MwUTF8ToUTF32
  MwUTF8Length
  MwUTF8Copy
  MwUTF32ToUTF8
Mw/Widget/Button.h
  MwButtonClass
Mw/Widget/CheckBox.h
  MwCheckBoxClass
Mw/Widget/Entry.h
  MwEntryClass
Mw/Widget/Frame.h
  MwFrameClass
Mw/Widget/Image.h
  MwImageClass
Mw/Widget/Label.h
  MwLabelClass
Mw/Widget/ListBox.h
  MwListBoxClass
  MwListBoxInsert
  MwListBoxDelete
Mw/Widget/Menu.h
  MwMenuClass
  MwMenuAdd
Mw/Widget/NumberEntry.h
  MwNumberEntryClass
Mw/Widget/OpenGL.h
  MwOpenGLClass
  MwOpenGLMakeCurrent
  MwOpenGLGetProcAddress
  MwOpenGLSwapBuffer
Mw/Widget/ScrollBar.h
  MwScrollBarClass
  MwScrollBarGetVisibleLength
Mw/Widget/SubMenu.h
  MwSubMenuClass
Mw/Widget/Viewport.h
  MwViewportClass
  MwViewportGetViewport
  MwViewportSetSize
Mw/Widget/Vulkan.h
  MwVulkanClass
  MwVulkanEnableExtension
  MwVulkanEnableLayer
  MwVulkanConfig_T
  api_version
  vk_version
  validation_layers
  MwVulkanConfigure
  MwVulkanField_T
  MwVulkanField_GetInstanceProcAddr
  MwVulkanField_Instance
  MwVulkanField_Surface
  MwVulkanField_PhysicalDevice
  MwVulkanField_LogicalDevice
  MwVulkanField_GraphicsQueueIndex
  MwVulkanField_PresentQueueIndex
  MwVulkanField_PresentQueue
  MwVulkanGetField
  MwVulkanSupported
Mw/Widget/Window.h
  MwWindowClass
  MwWindowMakeBorderless

## Mw/Constants.h

Constants.

    enum MwDIRECTION;

  Direction enumeration.

    enum MwORIENTATION;

  Orientation.

    enum MwALIGNMENT;

  Alignment.

    #define MwDEFAULT 0x0fffffff

  Default.

    #define MwMB_ICONMASK 0xf

  Icon mask.

    #define MwMB_BUTTONMASK 0xf0

  Button mask.

    #define MwMB_BUTTONOK 0x10

  OK button.

    #define MwMB_BUTTONCANCEL 0x20

  Cancel button.

    #define MwMB_BUTTONYES 0x40

  Yes button.

    #define MwMB_BUTTONNO 0x80

  No button.

    #define MwMB_BUTTONOKCANCEL (MwMB_BUTTONCANCEL | MwMB_BUTTONOK)

  Ok and Cancel button.

    #define MwMB_BUTTONYESNO (MwMB_BUTTONYES | MwMB_BUTTONNO)

  Yes and No button.

    #define MwMB_BUTTONYESNOCANCEL (MwMB_BUTTONYES | MwMB_BUTTONNO | MwMB_BUTTONCANCEL)

  Yes, No and Cancel button.

## Mw/Core.h

Core.

    #define MwDispatch(x, y)

  Dispatches the handler of widget class.

| Used internally.

Parameter `x`
  Widget.
Parameter `y`
  Handler name.

    #define MwDispatch2(x, y)

  Dispatches the handler of widget class.

| Used internally.

Parameter `x`
  Widget.
Parameter `y`
  Handler name.
Returns
  `0` for success, otherwise failed.

    #define MwDispatch3(x, y, z)

  Dispatches the handler of widget class.

| Used internally.

Parameter `x`
  Widget.
Parameter `y`
  Handler name.
Parameter `z`
  Argument.

    MWDECL MwWidget MwCreateWidget (
    	MwClass widget_class,
    	const char* name,
    	MwWidget parent,
    	int x,
    	int y,
    	unsigned int width,
    	unsigned int height
    );

  Creates a widget.
Parameter `widget_class`
  Widget class.
Parameter `name`
  Widget name.
Parameter `parent`
  Parent widget or `NULL`.
Parameter `x`
  X.
Parameter `y`
  Y.
Parameter `width`
  Width.
Parameter `height`
  Height.
Returns
  Widget.

    MWDECL MwWidget MwVaCreateWidget (
    	MwClass widget_class,
    	const char* name,
    	MwWidget parent,
    	int x,
    	int y,
    	unsigned int width,
    	unsigned int height,
    	...
    );

  Creates a widget.
Parameter `widget_class`
  Widget class.
Parameter `name`
  Widget name.
Parameter `parent`
  Parent widget or `NULL`.
Parameter `x`
  X.
Parameter `y`
  Y.
Parameter `width`
  Width.
Parameter `height`
  Height.
Parameter `...`
  Same with MwVaApply.
Returns
  Widget.

    MWDECL MwWidget MwVaListCreateWidget (
    	MwClass widget_class,
    	const char* name,
    	MwWidget parent,
    	int x,
    	int y,
    	unsigned int width,
    	unsigned int height,
    	va_list va
    );

  Creates a widget.
Parameter `widget_class`
  Widget class.
Parameter `name`
  Widget name.
Parameter `parent`
  Parent widget or `NULL`.
Parameter `x`
  X.
Parameter `y`
  Y.
Parameter `width`
  Width.
Parameter `height`
  Height.
Parameter `va`
  Same with MwVaListApply.
Returns
  Widget.

    MWDECL void MwDestroyWidget (
    	MwWidget handle
    );

  Destroys the widget and its child widgets.
Parameter `handle`
  Widget.

    MWDECL void MwLoop (
    	MwWidget handle
    );

  Runs the main loop.
Parameter `handle`
  Widget.

    MWDECL void MwStep (
    	MwWidget handle
    );

  Runs the single step.
Parameter `handle`
  Widget.

    MWDECL int MwPending (
    	MwWidget handle
    );

  Check if any event is pending.
Parameter `handle`
  Widget.
Returns
  `1` if any event is pending.

    MWDECL void MwSetInteger (
    	MwWidget handle,
    	const char* key,
    	int n
    );

  Sets an integer property.
Parameter `handle`
  Widget.
Parameter `key`
  Key.
Parameter `n`
  Value.

    MWDECL void MwSetText (
    	MwWidget handle,
    	const char* key,
    	const char* value
    );

  Sets a text property.
Parameter `handle`
  Widget.
Parameter `key`
  Key.
Parameter `value`
  Value.

    MWDECL void MwSetVoid (
    	MwWidget handle,
    	const char* key,
    	void* value
    );

  Sets a void pointer property.
Parameter `handle`
  Widget.
Parameter `key`
  Key.
Parameter `value`
  Value.

    MWDECL int MwGetInteger (
    	MwWidget handle,
    	const char* key
    );

  Gets the integer property.
Parameter `handle`
  Widget.
Parameter `key`
  Key.
Returns
  Value.

    MWDECL const char* MwGetText (
    	MwWidget handle,
    	const char* key
    );

  Gets the text property.
Parameter `handle`
  Widget.
Parameter `key`
  Key.
Returns
  Value.

    MWDECL void* MwGetVoid (
    	MwWidget handle,
    	const char* key
    );

  Gets the void pointer property.
Parameter `handle`
  Widget.
Parameter `key`
  Key.
Returns
  Value.

    MWDECL void MwSetDefault (
    	MwWidget handle
    );

  Sets the default property.

| This is called when widget is created.

Parameter `handle`
  Widget.

    MWDECL void MwVaApply (
    	MwWidget handle,
    	...
    );

  Sets the properties.
Parameter `handle`
  Widget.
Parameter `...`
  Properties.

    MWDECL void MwVaListApply (
    	MwWidget handle,
    	va_list va
    );

  Sets properties.
Parameter `handle`
  Widget.
Parameter `va`
  Properties.

    MWDECL void MwAddUserHandler (
    	MwWidget handle,
    	const char* key,
    	MwUserHandler handler,
    	void* user_data
    );

  Sets a user handler.
Parameter `handle`
  Widget.
Parameter `key`
  Key.
Parameter `handler`
  Handler.
Parameter `user_data`
  User data passed to handler.

    MWDECL void MwDispatchUserHandler (
    	MwWidget handle,
    	const char* key,
    	void* handler_data
    );

  Dispatches the user handler.
Parameter `handle`
  Widget.
Parameter `key`
  Key.
Parameter `handler_data`
  Handler data passed to handler.

    MWDECL void MwSetErrorHandler (
    	MwErrorHandler handler,
    	void* user_data
    );

  Sets an error handler.
Parameter `handle`
  Widget.
Parameter `handler`
  Handler.
Parameter `user_data`
  User data passed to handler.

    MWDECL void MwDispatchError (
    	int code,
    	const char* message
    );

  Dispatches the error handler.
Parameter `code`
  Error code.
Parameter `message`
  Error message.

    MWDECL void MwGetBeforeStep (
    	MwWidget handle,
    	jmp_buf* jmpbuf
    );

  Gets the before_step of widget.
Parameter `handle`
  Widget.
Parameter `jmpbuf`
  jmp_buf.

    MWDECL void MwForceRender (
    	MwWidget handle
    );

  Forcefully makes widget render.
Parameter `handle`
  Widget.

    MWDECL void MwForceRender2 (
    	MwWidget handle,
    	void* ptr
    );

  Forcefully makes widget render.
Parameter `handle`
  Widget.
Parameter `ptr`
  Ignored.

## Mw/Cursor.h

Cursor externs.

    MWDECL MwCursor MwCursorDefault;

  Default cursor.

    MWDECL MwCursor MwCursorDefaultMask;

  Default cursor mask.

    MWDECL MwCursor MwCursorCross;

  Cross cursor.

    MWDECL MwCursor MwCursorCrossMask;

  Cross cursor mask.

    MWDECL MwCursor MwCursorText;

  Text cursor.

    MWDECL MwCursor MwCursorTextMask;

  Text cursor mask.

## Mw/Default.h

Default properties.

    MWDECL const char* MwDefaultBackground;

  Default background color.

    MWDECL const char* MwDefaultForeground;

  Default foreground color.

    MWDECL const int MwDefaultBorderWidth;

  Default border width.

## Mw/Draw.h

Common drawing API.

    MWDECL MwLLColor MwParseColor (
    	MwWidget handle,
    	const char* text
    );

  Parses a color text.
Parameter `handle`
  Widget.
Parameter `text`
  Color text.
Returns
  Color.

    MWDECL MwLLColor MwLightenColor (
    	MwWidget handle,
    	MwLLColor color,
    	int r,
    	int g,
    	int b
    );

  Lighten a color.
Parameter `handle`
  Widget.
Parameter `color`
  Color.
Parameter `r`
  Red.
Parameter `g`
  Green.
Parameter `b`
  Blue.
Returns
  Color.

    MWDECL void MwDrawRect (
    	MwWidget handle,
    	MwRect* rect,
    	MwLLColor color
    );

  Draws a filled rectangle.
Parameter `handle`
  Widget.
Parameter `rect`
  Rectangle area.
Parameter `color`
  Color.

    MWDECL void MwDrawFrame (
    	MwWidget handle,
    	MwRect* rect,
    	MwLLColor color,
    	int invert
    );

  Draws a frame.

| `rect` gets changed to the area of rectangle inside.

Parameter `handle`
  Widget.
Parameter `rect`
  Rectangle area.
Parameter `color`
  Color.
Parameter `invert`
  Invert the 3D border color or not.

    MWDECL void MwDrawTriangle (
    	MwWidget handle,
    	MwRect* rect,
    	MwLLColor color,
    	int invert,
    	int direction
    );

  Draws a triangle.
Parameter `handle`
  Widget.
Parameter `rect`
  Rectangle area.
Parameter `color`
  Color.
Parameter `invert`
  Invert the 3D border color or not.

    MWDECL void MwDrawFrameEx (
    	MwWidget handle,
    	MwRect* rect,
    	MwLLColor color,
    	int invert,
    	int border
    );

  Draws a frame with specified border width.

| `rect` gets changed to the area of rectangle inside.

Parameter `handle`
  Widget.
Parameter `rect`
  Rectangle area.
Parameter `color`
  Color.
Parameter `invert`
  Invert the 3D border color or not.
Parameter `border`
  Border width.

    MWDECL void MwDrawText (
    	MwWidget handle,
    	MwPoint* point,
    	const char* text,
    	int bold,
    	int align,
    	MwLLColor color
    );

  Draws a text.
Parameter `handle`
  Widget.
Parameter `point`
  Center point of the text.
Parameter `text`
  Text.
Parameter `bold`
  Bold.
Parameter `align`
  Align.
Parameter `color`
  Color.

    MWDECL void MwDrawTextEx (
    	MwWidget handle,
    	MwPoint* point,
    	const char* text,
    	int bold,
    	int align,
    	MwLLColor color,
    	MwLLColor bgcolor
    );

  Draws a text.
Parameter `handle`
  Widget.
Parameter `point`
  Center point of the text.
Parameter `text`
  Text.
Parameter `bold`
  Bold.
Parameter `align`
  Align.
Parameter `color`
  Color.
Parameter `bgcolor`
  Background color.

    MWDECL MwLLPixmap MwLoadImage (
    	MwWidget handle,
    	const char* path
    );

  Creates a pixmap from image.
Parameter `handle`
  Widget.
Parameter `path`
  Path.
Returns
  Pixmap.

    MWDECL int MwTextWidth (
    	MwWidget handle,
    	const char* text
    );

  Calculates a text width.
Parameter `handle`
  Widget.
Parameter `text`
  Text.
Returns
  Text width.

    MWDECL int MwTextHeight (
    	MwWidget handle,
    	const char* text
    );

  Calculates a text height.
Parameter `handle`
  Widget.
Parameter `text`
  Text.
Returns
  Text height.

    MWDECL void MwGetColor (
    	MwLLColor color,
    	int* red,
    	int* green,
    	int* blue
    );

  Get color components.
Parameter `color`
  Color.
Parameter `red`
  Pointer to red color.
Parameter `green`
  Pointer to green color.
Parameter `blue`
  Pointer to blue color.

    MWDECL MwLLPixmap MwLoadRaw (
    	MwWidget handle,
    	unsigned char* rgb,
    	int width,
    	int height
    );

  Creates a pixmap from raw data.
Parameter `handle`
  Widget.
Parameter `rgb`
  RGBA data.
Parameter `width`
  Width.
Parameter `height`
  Height.
Returns
  Pixmap.

    MWDECL MwLLPixmap MwLoadXPM (
    	MwWidget handle,
    	char** data
    );

  Creates a pixmap from XPM data.
Parameter `handle`
  Widget.
Parameter `data`
  Data.
Returns
  Pixmap.

    MWDECL MwLLColor MwParseColorName (
    	MwWidget handle,
    	const char* color
    );

  Parses a color name.
Parameter `handle`
  Widget.
Parameter `color`
  Color name.
Returns
  Color.

## Mw/Error.h

Error codes.

    typedef enum MwErrorEnum_T;

  Error code enumeration.

     MwEsuccess = 0

  No error.

     MwEerror

  There was an error.

    MWDECL const char* MwGetLastError (
    	void
    );

  Get the last error.

## Mw/Font.h

Default font.

    MWDECL MwFont MwFontData[];

  Default font data.

    MWDECL MwFont MwBoldFontData[];

  Default bold font data.

## Mw/Icon.h

Icon.

    MWDECL char* MwIconError[];

  Error icon.

    MWDECL char* MwIconInfo[];

  Info icon.

    MWDECL char* MwIconNews[];

  News icon.

    MWDECL char* MwIconNote[];

  Note icon.

    MWDECL char* MwIconQuestion[];

  Question icon.

    MWDECL char* MwIconWarning[];

  Warning icon.

## Mw/LowLevel.h

Low-level drawing API.

| This is used internally.

## Mw/MachDep.h

Machine dependent headers and macros.

## Mw/MessageBox.h

Message box.

    MWDECL MwWidget MwMessageBox (
    	MwWidget handle,
    	const char* text,
    	const char* title,
    	unsigned int flag
    );

  Creates a message box.
Parameter `handle`
  Widget.
Parameter `text`
  Text.
Parameter `title`
  Title text.
Parameter `flag`
  Flag.
Returns
  Widget.

    MWDECL MwWidget MwMessageBoxGetChild (
    	MwWidget handle,
    	int child
    );

  Gets a child of the message box.
Parameter `handle`
  Widget.
Parameter `child`
  Child.

## Mw/Milsko.h

Includes all headers.

## Mw/StringDefs.h

String definitions for property.

## Mw/TypeDefs.h

Type definitions.

## Mw/Unicode.h

Handles UTF8 stuff.

    MWDECL int MwUTF8ToUTF32 (
    	const char* input,
    	int* output
    );

  output Output.
Returns
  Bytes this multibyte takes.

    MWDECL int MwUTF8Length (
    	const char* input
    );

  input Input.
Returns
  Length.

    MWDECL int MwUTF8Copy (
    	const char* src,
    	int srcskip,
    	char* dst,
    	int dstskip,
    	int len
    );

  len Length.
Returns
  Copied length in bytes.

    MWDECL int MwUTF32ToUTF8 (
    	int input,
    	char* output
    );

  output Output.
Returns
  Bytes this wide byte takes.

## Mw/Widget/Button.h

Button widget.

    MWDECL MwClass MwButtonClass;

  Button widget class.

## Mw/Widget/CheckBox.h

CheckBox widget.

    MWDECL MwClass MwCheckBoxClass;

  CheckBox widget class.

## Mw/Widget/Entry.h

Entry widget.

    MWDECL MwClass MwEntryClass;

  Entry widget class.

## Mw/Widget/Frame.h

Frame widget.

    MWDECL MwClass MwFrameClass;

  Frame widget class.

## Mw/Widget/Image.h

Image widget.

    MWDECL MwClass MwImageClass;

  Image widget class.

## Mw/Widget/Label.h

Label widget.

    MWDECL MwClass MwLabelClass;

  Label widget class.

## Mw/Widget/ListBox.h

ListBox widget.

    MWDECL MwClass MwListBoxClass;

  ListBox widget class.

    MWDECL void MwListBoxInsert (
    	MwWidget handle,
    	int index,
    	const char* text
    );

  Inserts item on the listbox.
Parameter `handle`
  Widget.
Parameter `index`
  Index.
Parameter `text`
  Text.

    MWDECL void MwListBoxDelete (
    	MwWidget handle,
    	int index
    );

  Deletes item from the listbox.
Parameter `handle`
  Widget.
Parameter `index`
  Index.

## Mw/Widget/Menu.h

Menu widget.

    MWDECL MwClass MwMenuClass;

  Menu widget class.

    MWDECL MwMenu MwMenuAdd (
    	MwWidget handle,
    	MwMenu menu,
    	const char* name
    );

  Adds a menu.
Parameter `handle`
  Widget.
Parameter `menu`
  Menu.
Parameter `name`
  Menu name.
Returns
  Menu.

## Mw/Widget/NumberEntry.h

NumberEntry widget.

    MWDECL MwClass MwNumberEntryClass;

  NumberEntry widget class.

## Mw/Widget/OpenGL.h

OpenGL widget.

    MWDECL MwClass MwOpenGLClass;

  OpenGL widget class.

    MWDECL void MwOpenGLMakeCurrent (
    	MwWidget handle
    );

  Make a widget current OpenGL context.
Parameter `handle`
  Widget.

    MWDECL void* MwOpenGLGetProcAddress (
    	MwWidget handle,
    	const char* name
    );

  Get a procedure from OpenGL.
Parameter `handle`
  Widget.
Parameter `name`
  Name.
Returns
  Procedure.

    MWDECL void MwOpenGLSwapBuffer (
    	MwWidget handle
    );

  Swaps the buffer of OpenGL context.
Parameter `handle`
  Widget.

## Mw/Widget/ScrollBar.h

ScrollBar widget.

    MWDECL MwClass MwScrollBarClass;

  ScrollBar widget class.

    MWDECL int MwScrollBarGetVisibleLength (
    	MwWidget handle
    );

  Calculates a visible length of scrollbar.
Parameter `handle`
  Widget.
Returns
  Visible length.

## Mw/Widget/SubMenu.h

SubMenu widget.

    MWDECL MwClass MwSubMenuClass;

  SubMenu widget class.

## Mw/Widget/Viewport.h

Viewport widget.

    MWDECL MwClass MwViewportClass;

  Viewport widget class.

    MWDECL MwWidget MwViewportGetViewport (
    	MwWidget handle
    );

  Get parent widget where widgets should be placed.
Parameter `handle`
  Widget.
Returns
  Widget.

    MWDECL void MwViewportSetSize (
    	MwWidget handle,
    	int w,
    	int h
    );

  Set viewport size.
Parameter `handle`
  Widget.
Parameter `w`
  Width.
Parameter `h`
  Height.

## Mw/Widget/Vulkan.h

Vulkan widget.

| This header is not documented yet.

    MWDECL MwClass MwVulkanClass;

  Vulkan widget class.

    MWDECL void MwVulkanEnableExtension (
    	const char* ext_name
    );

  Add an extension to the list of extensions to enable prior to initialization.

| This must be called before MwCreateWidget.

    MWDECL void MwVulkanEnableLayer (
    	const char* ext_name
    );

  Add an layer to the list of layers to enable prior to initialization.

| This must be called before MwCreateWidget.

    typedef struct MwVulkanConfig_T;

  Configuration options that can be passed to setup Vulkan before a widget is created.

     uint32_t api_version;

  Vulkan API version (default: VK_API_VERSION_1_0).

     uint32_t vk_version;

  Vulkan version (default: VK_VERSION_1_0).

     VkBool32 validation_layers;

  Whether or not to enable validation layers (default: false).

    MWDECL void MwVulkanConfigure (
    	MwVulkanConfig cfg
    );

  Configure Vulkan prior to initializing the widget.

| The configuration provided will be used for future initializations of the Vulkan widget (unless it's changed).

    typedef enum MwVulkanField_T;

  Field that can be gotten from Vulkan.

     MwVulkanField_GetInstanceProcAddr = 0

  The address of the vulkan widget's vkGetInstanceProcAddr function (PFN_vkGetInstanceProcAddr).

     MwVulkanField_Instance

  The address of the vulkan widget's instance (VkInstance).

     MwVulkanField_Surface

  The address of the vulkan widget's surface (VkSurfaceKHR).

     MwVulkanField_PhysicalDevice

  The address of the vulkan widget's physical device (VkPhysicalDevice).

     MwVulkanField_LogicalDevice

  The address of the vulkan widget's logical device (VkDevice).

     MwVulkanField_GraphicsQueueIndex

  The address of the index that the vulkan widget uses for the graphics queue (uint32_t *).

     MwVulkanField_PresentQueueIndex

  The address of the index that the vulkan widget uses for the present queue (uint32_t *).

     MwVulkanField_PresentQueue

  The address of the vulkan widget's graphics queue (VkQueue).

    MWDECL void* MwVulkanGetField (
    	MwWidget handle,
    	MwVulkanField field,
    	MwErrorEnum* out
    );

  Function for getting a field from within Vulkan.

| Consult the documentation for MwVulkanField to know what type is expected for out.

    MWDECL VkBool32 MwVulkanSupported (
    	void
    );

  Return whether Vulkan is installed on the target platform.

## Mw/Widget/Window.h

Window widget.

    MWDECL MwClass MwWindowClass;

  Window widget class.

    MWDECL void MwWindowMakeBorderless (
    	MwWidget handle,
    	int toggle
    );

  Makes window borderless.
Parameter `handle`
  Widget.
Parameter `toggle`
  Toggle.